#define VIDEO_SEG    0xA000

struct RGB {
  unsigned char r, g, b;
};

void far     *screenbuf;
void far     *font;

unsigned char RENDER_COLOR;
unsigned char FONT_HEIGHT;

void set_mode(unsigned int mode)
{
  asm
  {
      mov    ax,  mode
      int    10h
  }
}

unsigned char get_mode()
{
  asm
  {
      mov    ax,  0Fh
      int    10h
  }

  return _AL;
}

void put_pixel(unsigned int x, unsigned int y, unsigned char color)
{
  asm
  {
      cmp    x,   319
      ja     @1
      cmp    y,   199
      ja     @1
      push   es
      lea    di,  screenbuf
      xor    dx,  dx
      mov    di,  y
      shl    di,  6
      mov    bx,  y
      shl    bx,  8
      add    di,  bx
      add    di,  x
      mov    al,  color
      stosb
      pop    es
@1:
  }
}

unsigned char get_pixel(unsigned int x, unsigned int y)
{
  asm
  {
      cmp    x,   319
      ja     @1
      cmp    y,   199
      ja     @1
      push   ds
      lds    si,  screenbuf
      xor    dx,  dx
      mov    si,  y
      shl    si,  6
      mov    bx,  y
      shl    bx,  8
      add    si,  bx
      add    si,  x
      lodsb
      pop    ds
@1:
  }
  return _AL;
}

void cls(unsigned char color)
{
  asm
  {
      push   es
      les    di,  screenbuf
      mov    cx,  32000
      mov    al,  color
      mov    ah,  color
      rep    stosw
      pop    es
  }
}

void bar1(int x, int y, unsigned int w, unsigned int h, unsigned char color)
{
  if (x < 0) { w += x; x = 0; }
  if (y < 0) { h += y; y = 0; }

  if (x + w > 320) w = 320 - x;
  if (y + h > 200) h = 200 - y;

  if (w > 0 && h > 0)
  asm
  {
      push   es
      les    di,  screenbuf
      xor    dx,  dx
      mov    di,  y
      shl    di,  6
      mov    bx,  y
      shl    bx,  8
      add    di,  bx
      add    di,  x
      mov    al,  color
      mov    cx,  h
@1:   push   cx
      mov    cx,  w
      rep    stosb
      sub    di,  w
      add    di, 320
      pop    cx
      loop   @1
      pop    es
  }
}

void bar2(int x1, int y1, int x2, int y2, unsigned char color)
{
  if (x2 < x1) { int a = x1; x1 = x2; x2 = a; }
  if (y2 < y1) { int a = y1; y1 = y2; y2 = a; }
  bar1(x1, y1, x2 - x1, y2 - y1, color);
}

void put_render_image(int x1, int y1, unsigned int w, unsigned int h, unsigned int x2, unsigned int y2, unsigned int w_, void far *buf)
{
  int offs = y2 * w_ + x2;

  if (y1 < 0) { offs -= w * y1; h += y1; y1 = 0; }
  if (x1 < 0) { offs -= x1; w += x1; x1 = 0; }

  if (x1 + w > 320) w = 320 - x1;
  if (y1 + h > 200) h = 200 - y1;

  if (w > 0 && h > 0)
  asm
  {
      push   ds
      push   es
      les    di,  screenbuf
      lds    si,  buf
      mov    di,  y1
      shl    di,  6
      mov    bx,  y1
      shl    bx,  8
      add    di,  bx
      add    di,  x1
      mov    cx,  h
@1:   push   cx
      mov    cx,  w
@2:   mov    al,  ds:[si]
      cmp    al,  RENDER_COLOR
      je     @3
      movsb
      jmp    @4
@3:   inc si
      inc di
@4:   loop @2
      sub    di,  w
      add    di,  320
      sub    si,  w
      add    si,  w_
      pop    cx
      loop   @1
      pop   es
      pop   ds
  }
}

void put_image(int x1, int y1, unsigned int w, unsigned int h, unsigned int x2, unsigned int y2, unsigned int w_, void far *buf)
{
  int offs = y2 * w_ + x2;

  if (y1 < 0) { offs -= w * y1; h += y1; y1 = 0; }
  if (x1 < 0) { offs -= x1; w += x1; x1 = 0; }

  if (x1 + w > 320) w = 320 - x1;
  if (y1 + h > 200) h = 200 - y1;

  if (w > 0 && h > 0)
  asm
  {
      push   ds
      push   es
      les    di,  screenbuf
      lds    si,  buf
      mov    di,  y1
      shl    di,  6
      mov    bx,  y1
      shl    bx,  8
      add    di,  bx
      add    di,  x1
      mov    cx,  h
@1:   push   cx
      mov    cx,  w
      rep    movsb
      sub    di,  w
      add    di,  320
      sub    si,  w
      add    si,  w_
      pop    cx
      loop   @1
      pop   es
      pop   ds
  }
}

void get_image(int x, int y, unsigned int w, unsigned int h, void far *buf)
{
  asm
  {
      push   ds
      push   es
      les    di,  buf
      lds    si,  screenbuf
      mov    si,  y
      shl    si,  6
      mov    bx,  y
      shl    bx,  8
      add    si,  bx
      add    si,  x
      mov    cx,  h
@1:   push   cx
      mov    cx,  w
      rep    movsb
      sub    si,  w
      add    si,  320
      pop    cx
      loop   @1
      pop    es
      pop    ds
  }
}

void vert_line1(int x, int y, unsigned int h, unsigned char color)
{
  if (y < 0) { h += y; y = 0; }
  if (y + h > 200) h = 200 - y;
  if (h > 0)

  asm
  {
      push   es
      les    di,  screenbuf
      mov    di,  y
      shl    di,  6
      mov    bx,  y
      shl    bx,  8
      add    di,  bx
      add    di,  x
      mov    al,  color
      mov    cx,  h
@1:   stosb
      add    di,  319
      loop   @1
      pop    es
  }
}

void vert_line2(int x, int y1, int y2, unsigned char color)
{
  if (y2 < y1) { int a = y1; y1 = y2; y2 = a; }
  vert_line1(x, y1, y2 - y1, color);
}

void hor_line1(int x, int y, unsigned int w, unsigned char color)
{
  if (x < 0) { w += x; x = 0; }
  if (x + w > 320) w = 320 - x;
  if (w > 0)

  asm
  {
      push   es
      les    di,  screenbuf
      mov    di,  y
      shl    di,  6
      mov    bx,  y
      shl    bx,  8
      add    di,  bx
      add    di,  x
      mov    al,  color
      mov    cx,  w
      rep    stosb
      pop    es
  }
}

void hor_line2(int x1, int y, int x2, unsigned char color)
{
  if (x2 < x1) { int a = x1; x1 = x2; x2 = a; }
  hor_line1(x1, y, x2 - x1, color);
}

void rect1(int x, int y, unsigned int w, unsigned int h, unsigned char color)
{
  hor_line1(x, y, w, color);
  hor_line1(x, y + h - 1, w, color);
  vert_line1(x, y, h, color);
  vert_line1(x + w - 1, y, h, color);
}

void rect2(int x1, int y1, int x2, int y2, unsigned char color)
{
  hor_line2(x1, y1, x2, color);
  hor_line2(x1, y2, x2, color);
  vert_line2(x1, y1, y2, color);
  vert_line2(x2, y1, y2, color);
}

void copy_buf_to_screen(void far *buf)
{
  asm
  {
      push   ds
      push   es
      mov    ax,  VIDEO_SEG
      mov    es,  ax
      lds    si,  buf
      xor    di,  di
      xor    si,  si
      mov    ax,  32000
      rep    movsw
      pop    es
      pop    ds
  }
}

void copy_buf_to_buf(void far *buf1, void far *buf2)
{
  asm
  {
      push   ds
      push   es
      lds    si,  buf1
      les    di,  buf2
      xor    di,  di
      xor    si,  si
      mov    ax,  32000
      rep    movsw
      pop    es
      pop    ds
  }
}

void copy_screen_to_buf(void far *buf)
{
  asm
  {
      push   ds
      push   es
      mov    ax,  VIDEO_SEG
      mov    ds,  ax
      les    di,  buf
      xor    di,  di
      xor    si,  si
      mov    ax,  32000
      rep    movsw
      pop    es
      pop    ds
  }
}

void set_screen_buf(void far *buf)
{
  screenbuf = buf;
}

void free_screen_buf()
{
  delete screenbuf;
}

void vert_ret()
{
  asm
  {
      cli
      mov    dx,  03DAh
@1:   in     al,  dx
      test   al,  8
      jz     @1
@2:   in     al,  dx
      test   al,  8
      jnz    @2
      sti
  }
}

void set_rgb(unsigned char n, unsigned char r, unsigned char g, unsigned char b)
{
  asm
  {
      mov    dx,  3C8h
      mov    al,  n
      out    dx,  al
      inc    dx
      mov    al,  r
      shr    al,  2
      out    dx,  al
      mov    al,  g
      shr    al,  2
      out    dx,  al
      mov    al,  b
      shr    al,  2
      out    dx,  al
  }
}

void get_rgb(unsigned char n, RGB &color)
{
  char r, g, b;
  asm
  {
      mov    dx,  3C7h
      mov    al,  n
      out    dx,  al
      inc    dx
      inc    dx
      in     al,  dx
      shl    al,  4
      mov    r,  al
      in     al,  dx
      shl    al,  4
      mov    g,  al
      in     al,  dx
      shl    al,  4
      mov    b,  al
  }
  color.r = r;
  color.g = g;
  color.b = b;
}

void set_pal_768(unsigned char *pal)
{
  for(int i = 0; i < 256; i++)
    set_rgb(i, pal[i * 3], pal[i * 3 + 1], pal[i * 3 + 2]);
}

void set_pal_1024(unsigned char *pal)
{
  for(int i = 0; i < 256; i++)
    set_rgb(i, pal[i * 4 + 2], pal[i * 4 + 1], pal[i * 4]);
}

void get_pal_768(unsigned char *pal)
{
  RGB color;

  for(int i = 0; i < 256; i++)
  {
    get_rgb(i, color);
    pal[i * 3] = color.r;
    pal[i * 3 + 1] = color.g;
    pal[i * 3 + 2] = color.b;
  }
}

void get_pal_1024(unsigned char *pal)
{
  RGB color;

  for(int i = 0; i < 256; i++)
  {
    get_rgb(i, color);
    pal[i * 4] = color.b;
    pal[i * 4 + 1] = color.g;
    pal[i * 4 + 2] = color.r;
    pal[i * 4 + 3] = 0;
  }
}

void out_char(int x, int y, unsigned char ch, unsigned char color)
{
  unsigned char b;

  for (int i = 0; i < FONT_HEIGHT; i++)
  {
    asm
    {
      push ds
      lds si, font
      xor ah, ah
      mov al, ch
      mov bl, FONT_HEIGHT
      mul bl
      add ax, i
      add si, ax
      lodsb
      mov b, al
      pop ds
    }
    for (int j = 0; j < 8; j++)
      if (b & (1 << j))
        put_pixel(x + (7 - j), y + i, color);
  }
  ch;
}

void out_size_char(int x, int y, unsigned char ch, unsigned char color, unsigned char scale_x, unsigned char scale_y)
{
  unsigned char b;

  for (int i = 0; i < FONT_HEIGHT; i++)
  {
    asm
    {
      push ds
      lds si, font
      xor ah, ah
      mov al, ch
      mov bl, FONT_HEIGHT
      mul bl
      add ax, i
      add si, ax
      lodsb
      mov b, al
      pop ds
    }
    for (int j = 0; j < 8; j++)
      if (b & (1 << j))
        bar1(x + (7 - j) * scale_x, y + i * scale_y, scale_x, scale_y, color);
  }
  ch;
}

void out_string(int x, int y, char *s, unsigned char color)
{
  int i = 0;

  while(*s)
    out_char(x + i++ * 9, y, *s++, color);
}

void out_size_string(int x, int y, char *s, unsigned char color, unsigned char scale_x, unsigned char scale_y)
{
  int i = 0;

  while(*s)
    out_size_char(x + i++ * scale_x * 9, y, *s++, color, scale_x, scale_y);
}
