#ifndef _GRAPHICS_H_
#define _GRAPHICS_H_

struct RGB {
  unsigned char r, g, b;
};

extern unsigned char RENDER_COLOR;
extern unsigned char FONT_HEIGHT;
extern void far *fonts;

void set_mode(unsigned int mode);
unsigned char get_mode();
void put_pixel(unsigned int x, unsigned int y, unsigned char color);
unsigned char get_pixel(unsigned int x, unsigned int y);
void cls(unsigned char color);
void bar1(int x, int y, unsigned int w, unsigned int h, unsigned char color);
void bar2(int x1, int y1, int x2, int y2, unsigned char color);
void rect1(int x, int y, unsigned int w, unsigned int h, unsigned char color);
void rect2(int x1, int y1, int x2, int y2, unsigned char color);
void put_render_image(int x1, int y1, unsigned int w, unsigned int h, unsigned int x2, unsigned int y2, unsigned int w_, void far *buf);
void put_image(int x1, int y1, unsigned int w, unsigned int h, unsigned int x2, unsigned int y2, unsigned int w_, void far *buf);
void get_image(int x, int y, unsigned int w, unsigned int h, void far *buf);
void vert_line1(int x, int y, unsigned int h, unsigned char color);
void vert_line2(int x, int y1, int y2, unsigned char color);
void hor_line1(int x, int y, unsigned int w, unsigned char color);
void hor_line2(int x1, int y, int x2, unsigned char color);

void copy_buf_to_screen(void far *buf);
void copy_buf_to_buf(void far *buf1, void far *buf2);
void copy_screen_to_buf(void far *buf);
void set_screen_buf(void far *buf);
void free_screen_buf(void far *buf);

void vert_ret();
void set_rgb(unsigned char n, unsigned char r, unsigned char g, unsigned char b);
void get_rgb(unsigned char n, RGB &color);
void set_pal_768(unsigned char *pal);
void set_pal_1024(unsigned char *pal);
void get_pal_768(unsigned char *pal);
void get_pal_1024(unsigned char *pal);

void out_char(int x, int y, unsigned char ch, unsigned char color);
void out_string(int x, int y, char *s, unsigned char color);
void out_size_char(int x, int y, unsigned char ch, unsigned char color, unsigned char scale_x, unsigned char scale_y);
void out_size_string(int x, int y, char *s, unsigned char color, unsigned char scale_x, unsigned char scale_y);


#endif
